describe("Alias game module",
function() {
    it("should have 0 points on start of game",
    function() {
        alias.newGame();
        expect(alias.getPoints()).toEqual(0);
    });
});

var TEST_SIXTY_SECONDS = 60 * 1000;

describe("Alias timing module",
function() {
    beforeEach(function() {
        this.clock = sinon.useFakeTimers();
        alias.newGame();
        alias.newWord = function() {};
    });

    afterEach(function() {
        this.clock.restore();
    });

    it("should add one point on correct world",
    function() {
        alias.correctWord();
        expect(alias.getPoints()).toEqual(1);
    });
    it("should decrement one point on skipped word",
    function() {
        alias.skipWord();
        expect(alias.getPoints()).toEqual( - 1);
    });
    it("should have one point after 6 points and 5 skip",
    function() {
        round(6, 5);
        expect(alias.getPoints()).toEqual(1);
    });
    it("should not be able to add points after 60 sec",
    function() {
        round(1, 0);
        this.clock.tick(TEST_SIXTY_SECONDS);
        round(1, 0);
        expect(alias.getPoints()).toEqual(1);
    });
    xit("should have 1 point if one 1 word is correct: async",
    function() {
        runs(function() {
            alias.correctWord();
        });
        waits(TEST_SIXTY_SECONDS);
        waits(500);
        runs(function() {
            alias.correctWord();
            expect(alias.getPoints()).toEqual(1);
        });
    });

});

function round(correct, skips) {
    for (var i = 0; i < correct; i++) {
        alias.newWord();
        alias.correctWord();
    };
    for (var i = 0; i < skips; i++) {
        alias.newWord();
        alias.skipWord();
    };

};