function parseTrendNames() {
    var trendNames = [];
    try {
        var trends = JSON.parse(lastResponse.get());
        for (var i = 0; i < trends.trends.length; i++) {
            trendNames[i] = trends.trends[i].name
        };
    } catch(er) {
        trendNames = {
            message: 'Unable to connect to Twitter'
        };
    };
    trendNames.returnTop = function(number) {
        if (!this.message) {
            return trendNames.slice(0, number);
        } else {
            return trendNames;
        }

    };
    return trendNames;
};

function fetchTrends(xhr) {

    xhr.onreadystatechange = function() {
        if (xhr.readyState == 4) {
            if (xhr.status == 200) {
                lastResponse.save(xhr.responseText);
            } else {
                lastResponse.save(null);
            }

        }
    };

    xhr.open('get', 'http://api.twitter.com/1/trends.json', true);
    xhr.send();
}

function createXmlHttpRequest() {
    var xmlHttp;
    if (window.XMLHttpRequest) {
        xmlHttp = new XMLHttpRequest();
    } else {
        try {
            xmlHttp = new ActiveXObject("Msxml2.XMLHTTP");
        } catch(e) {
            try {
                xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
            } catch(e) {
                throw (e);
            }
        }
    };
    return xmlHttp;
};

var lastResponse = (function() {
    var lastResponse;
    return {
        save: function(input) {
            this.lastResponse = input;
        },
        get: function() {
            if (this.lastResponse !== null) {
                return this.lastResponse;
            } else {
                throw {
                    name: 'NoResponseException',
                    message: 'Unable to connect to Twitter'
                };
            }
        }

    }

})();

