describe("startGame", function() {
	it("should start with 0 points", function() {
		var alias = startAlias();
		expect(alias.points).toEqual(0);
	});
});

describe("ALIAS round timing", function() {
		var alias;
		var newWordToRestore; 
		beforeEach(function(){
			alias = startAlias();	
			alias.newRound();
			newWordToRestore = alias.newWord;
			alias.newWord = function (){return "test"};
			});
		afterEach(function(){
			alias.newWord = newWordToRestore;
		});
	it("should give 1 points if one word is correct", function() {
		alias.ok();
		expect(alias.points).toEqual(1);
	});
	it("should give no points if time is up", function() {
		alias.ok();
		expect(alias.points).toEqual(1);
		
		alias.timeleft = 0;
		alias.ok();
		expect(alias.points).toEqual(1);
	});
	xit("should have 1 point if one 1 word is correct: async", function() {
		runs(function(){
			alias.ok();
	});
		waits(60*1000);
		waits(500);	
		runs(function(){
			alias.ok();
			expect(alias.points).toEqual(1);
			});
	});
	
	it("should have 1 points, 6 ok, 5 pass", function() {
	round(alias, 6, 5);
	expect(alias.points).toEqual(1);
	alias.timeleft = 0;
	round(alias, 6, 5);
	expect(alias.points).toEqual(1);
	});
});

function round(game, okays, passes){
	for(var i = 0; i < okays; i++){
		game.ok();
	};
	for(var i = 0; i < passes; i++){
		game.pass();
	};
};
