var SIXTY_SECONDS = 60 *1000;

describe("startGame", function() {
	it("should start with 0 points", function() {
		var game = startAlias();
		expect(game.points).toEqual(0);
	});
});

describe("Word fetch", function() {
  	it("should return a non-empty word", function() {
  	  var game = startAlias();

	  spyOn(game, 'newWord').andReturn('testword');

	  expect(game.newWord()).not.toEqual('');
  	});
});

describe("ALIAS round", function() {
	var g;
	 beforeEach(function() {
		  g = startAlias();
		  g.newWord = function () {};
		});
	
	it("should have 1 point if one 1 word is correct", function() {
		var game = startAlias();
		game.newWord = function () {};
			runs(function(){
			game.newWord();
			game.ok();
	});
		waits(SIXTY_SECONDS);
		runs(function(){
			game.ok();
			expect(game.points).toEqual(1);
			});
	});
	
	it("should have -1 point if no words are correct", function() {
		runs(function(){
			g.newWord();
			g.pass();
	});
		waits(SIXTY_SECONDS);
		runs(function(){
			g.pass();
			expect(g.points).toEqual(-1);
			});
	});
	
	it("should have 1 point after a a round of 6 ok and 5 pass", function() {
		var alias = startAlias();
		alias.newWord = function () {};
		runs(function(){
			round(alias, 6, 5);
	});
		waits(SIXTY_SECONDS);
		runs(function(){
			round(alias, 6, 5);
			expect(alias.points).toEqual(1);
			});
	});
});

var round = function (game, accepts, passes){
	for (var i=0; i < accepts; i++) {
		game.newWord();
		game.ok();
		};
	for (var i=0; i < passes; i++) {
		game.newWord();
		game.pass();
		};
};