describe("DOM helper", function() {
	var node; 
	var insert;
	beforeEach(function() {
		insert = document.createElement('div');
		insert.id = 'text';
		var insertText = document.createTextNode('SomeContent'); 
		insert.appendChild(insertText);
		document.body.appendChild(insert);
		node = fetchNode();
		
	});
	afterEach(function() {
	  document.body.removeChild(node);
	});
	it("should fetch DOM node with id text", function() {
		expect(node.id).toEqual("text");
	});
	it("check that the text content of the node is SomeContent", function() {
		expect(node.innerText).toEqual("SomeContent");
	});
	it("should change node text through updateText", function() {
		node.updateText("innerText");
		expect(node.hasOwnProperty("innerText")).toEqual(true);				
		expect(node.innerText).toEqual("innerText");
	});	
});