var SIXTY_SECONDS = 60 * 1000;

TestCase("Alias NewGame Test", sinon.testCase({
	"test should start a new game with 0 points": function(){
		alias.newGame();
		assertEquals(0, alias.getPoints());
	}
}));
var bool;
var game = alias;

TestCase("Alias NewWord test", sinon.testCase({
	setUp: function(){
		
	},
	"test newWord should return a non-empty String": function(){
		alias.newGame();
		alias.newWord = sinon.stub().returns("stubbed");
		assertNotEquals(alias.newWord(), '');
	}
}));


TestCase("Alias RoundTiming Test", sinon.testCase({
	setUp: function(){
		this.clock = sinon.useFakeTimers();
		alias.newGame();
		alias.newWord = sinon.stub().returns("stubbed");
	},
	tearDown: function () {
        this.clock.restore();
    },
 
	"test should add one point for an ok": function(){
		round(1, 0);
		assertEquals(1, alias.getPoints());
	},
	
	"test should remove one point when pass on a word": function(){
		round(0, 1);
		assertEquals(-1, alias.points);
	},
	
	"test should give 1 point for 6 okays and 6 passed": function(){
		round(6, 5);
		assertEquals(1, alias.getPoints());
	},
	"test round ends after 60 sec": function(){
		//this.clock.tick(SIXTY_SECONDS);
		alias.endGame();
		assertEquals(false, alias.inPlay);	
	},
	"test no points added after 60 seconds": function(){
		round(1, 0);
		//this.clock.tick(SIXTY_SECONDS);
		alias.endGame();
		round(1, 0);
		assertEquals("One point only", 1, alias.getPoints());	
	}
}));

function round(okays, passes) {
	for (var i=0; i < okays; i++) {
		alias.newWord();
		alias.ok();
		};
	for (var i=0; i < passes; i++) {
		alias.newWord();
		alias.pass();
		};	
};

