var response = '{"as_of":"Fri, 20 May 2011 12:50:45 +0000","trends":[{"url":"http:\/\/search.twitter.com\/search?q=%23akpyeoyvermeyecegim","name":"#akpyeoyvermeyecegim"},{"url":"http:\/\/search.twitter.com\/search?q=Sinterklaasjournaal%27","name":"Sinterklaasjournaal"},{"url":"http:\/\/search.twitter.com\/search?q=%23servergate","name":"#servergate"},{"url":"http:\/\/search.twitter.com\/search?q=AqOeHh+Chuyun9+QmoeHh","name":"AqOeHh Chuyun9 QmoeHh"},{"url":"http:\/\/search.twitter.com\/search?q=%23greysontoindonesia","name":"#greysontoindonesia"},{"url":"http:\/\/search.twitter.com\/search?q=mU4cHh","name":"mU4cHh"},{"url":"http:\/\/search.twitter.com\/search?q=Percy+Pig","name":"Percy Pig"},{"url":"http:\/\/search.twitter.com\/search?q=B2STISTHEBEST","name":"B2STISTHEBEST"},{"url":"http:\/\/search.twitter.com\/search?q=SmileMusicVideo","name":"SmileMusicVideo"},{"url":"http:\/\/search.twitter.com\/search?q=Pete+Doherty","name":"Pete Doherty"}]}';

TestCase("Twitter trends application", sinon.testCase({
	setUp: function(){
		this.server = sinon.fakeServer.create();
		// this.server.respondWith("GET", "http://api.twitter.com/1/trends.json",
		// 		                                [200, { "Content-Type": "application/json" },
		// 										'{"as_of":"Fri, 20 May 2011 12:50:45 +0000","trends":[{"url":"http:\/\/search.twitter.com\/search?q=%23akpyeoyvermeyecegim","name":"#akpyeoyvermeyecegim"},{"url":"http:\/\/search.twitter.com\/search?q=Sinterklaasjournaal%27","name":"Sinterklaasjournaal"},{"url":"http:\/\/search.twitter.com\/search?q=%23servergate","name":"#servergate"},{"url":"http:\/\/search.twitter.com\/search?q=AqOeHh+Chuyun9+QmoeHh","name":"AqOeHh Chuyun9 QmoeHh"},{"url":"http:\/\/search.twitter.com\/search?q=%23greysontoindonesia","name":"#greysontoindonesia"},{"url":"http:\/\/search.twitter.com\/search?q=mU4cHh","name":"mU4cHh"},{"url":"http:\/\/search.twitter.com\/search?q=Percy+Pig","name":"Percy Pig"},{"url":"http:\/\/search.twitter.com\/search?q=B2STISTHEBEST","name":"B2STISTHEBEST"},{"url":"http:\/\/search.twitter.com\/search?q=SmileMusicVideo","name":"SmileMusicVideo"},{"url":"http:\/\/search.twitter.com\/search?q=Pete+Doherty","name":"Pete Doherty"}]}']);
     },
	tearDown: function () {
		this.server.restore();
	},
	"test create XmlHttpRequest": function(){
		var xmlhttp = createXmlHttpRequest();
		
		assertNotUndefined(xmlhttp);
	},
	"test the last call method": function(){
		useCorrectResponse(this.server);
		
		fetchTrends();	
		this.server.respond();
		
		assertEquals(response, lastCall.get());

	},
	"test that top two trends are printed": function(){	
		useCorrectResponse(this.server);
		
		fetchTrends();
		this.server.respond();	
		var topTwoTrends = printTrends();	
		
		assertEquals('#akpyeoyvermeyecegim', topTwoTrends[0]);
		assertEquals('Sinterklaasjournaal', topTwoTrends[1]);
		assertEquals(2, topTwoTrends.length);
	},
	"test that an exception is thrown when the response is empty": function(){
		useEmptyResponse(this.server);
		
		try{
			fetchTrends();
			this.server.respond();
			lastCall.get();
			fail('It was supposed to thow an exception due to empty response');
		}
		catch(er){
			assertEquals('ResponseTextEmptyException', er.name);
		};
	},
	"test that printTrend prints 'Empty response from Twitter'": function(){
		useEmptyResponse(this.server);
		fetchTrends();
		this.server.respond();
		
		var topTwoTrends = printTrends();	
		
		assertEquals('Empty response from Twitter', topTwoTrends);
	}
}));

function useCorrectResponse (server) {
	server.respondWith("GET", "http://api.twitter.com/1/trends.json",
	                                [200, { "Content-Type": "application/json" },
									'{"as_of":"Fri, 20 May 2011 12:50:45 +0000","trends":[{"url":"http:\/\/search.twitter.com\/search?q=%23akpyeoyvermeyecegim","name":"#akpyeoyvermeyecegim"},{"url":"http:\/\/search.twitter.com\/search?q=Sinterklaasjournaal%27","name":"Sinterklaasjournaal"},{"url":"http:\/\/search.twitter.com\/search?q=%23servergate","name":"#servergate"},{"url":"http:\/\/search.twitter.com\/search?q=AqOeHh+Chuyun9+QmoeHh","name":"AqOeHh Chuyun9 QmoeHh"},{"url":"http:\/\/search.twitter.com\/search?q=%23greysontoindonesia","name":"#greysontoindonesia"},{"url":"http:\/\/search.twitter.com\/search?q=mU4cHh","name":"mU4cHh"},{"url":"http:\/\/search.twitter.com\/search?q=Percy+Pig","name":"Percy Pig"},{"url":"http:\/\/search.twitter.com\/search?q=B2STISTHEBEST","name":"B2STISTHEBEST"},{"url":"http:\/\/search.twitter.com\/search?q=SmileMusicVideo","name":"SmileMusicVideo"},{"url":"http:\/\/search.twitter.com\/search?q=Pete+Doherty","name":"Pete Doherty"}]}']);
};

function useEmptyResponse (server) {
	server.respondWith("GET", "http://api.twitter.com/1/trends.json", 
									[200, { "Content-Type": "application/json" },
	                                 '']);
	
};