module('at game start');

test('a game starts with 0 points', function() {
	alias.newGame();
	equal(alias.getScore(), 0);
});

var SIXTY_SECONDS = 60 *1000;

module('a game round', {
	setup: function() {
		tinesfakeClock.useFake();
		alias.newGame();
		alias.newWord = function () {};
	},
	teardown: function() {
		tinesfakeClock.restore()
	}
});

test('a point is given when a word is accepted', function() {
	alias.newWord();
	alias.acceptWord();
	equal(alias.getScore(), 1);
});

test('a point is given when a word is passed', function() {
	alias.newWord();
	alias.passWord();
	equal(alias.getScore(), -1);
});

test('no points given when the timelimit is exceeded', function() {
	alias.newWord();
	alias.acceptWord();
	equal(alias.getScore(), 1);
	tinesfakeClock.get().tick(SIXTY_SECONDS);
	alias.newWord();
	alias.acceptWord();
	equal(alias.getScore(), 1);
	
});

var tinesfakeClock = (function () {
	var fakeClock;
	return { useFake : function () {
		this.fakeClock = sinon.useFakeTimers();
	},
		restore : function () {
			this.fakeClock.restore()
		},
		get : function () {
			return this.fakeClock;
		}
	}
})();
