var SIXTY_SECONDS = 60 * 1000;

module('at game start');

test('a game starts with 0 points', function() {
	var game = startGame();
	equal(game.points, 0);
});

var game; 

module('a game round', {
	setup: function() {
		game = startGame();
		game.newWord = function () {};
	},
	teardown: function() {
		
	}
});

test('a point i given when a word is accepted', function() {
	game.newWord();
	game.acceptWord();
	equal(game.points, 1);
});

test('a point i given when a word is passed on', function() {
	game.newWord();
	game.passWord();
	equal(game.points, -1);
});

test('mocked inPlay : no points given when the timelimit is exceeded', function() {
	game.newWord();
	game.acceptWord();
	equal(game.points, 1);
	game.inPlay = false; 
	game.newWord();
	game.acceptWord();
	equal(game.points, 1);
	
});

asyncTest('no points are given if the time limt is exceeded', 2, function() {
	game.newWord();
	game.acceptWord();
	equal(game.points, 1);
	setTimeout(function () {
		game.newWord();
		game.acceptWord();
		equal(game.points, 1);
		start();
	}, SIXTY_SECONDS);
});