module('twitter trends', {
	setup: function() {
		lastCall = returnLastCall('');
	},
	teardown: function() {
		lastCall = returnLastCall('');
		
	}
});

test('create XmlHttpRequest', function() {
	var xmlHttp = createXmlHttpRequest();
	equal(typeof xmlHttp, 'object');
});

test('test that send is invoked', function() {
 	var xmlHttp = fakeXhr();
	ok(!xmlHttp.sendcalled);

	fetchTrends(xmlHttp);						
	ok(xmlHttp.sendcalled);
});

test('test that send is invoked with the right args', function() {
 	var xmlHttp = fakeXhr();
	fetchTrends(xmlHttp);						
	equal(xmlHttp.openargs[0], 'GET');
	equal(xmlHttp.openargs[1], 'http://api.twitter.com/1/trends.json');
	equal(xmlHttp.openargs[2], true);
	equal(3, xmlHttp.openargs.length);
});

test('test lastCall returns last call', function() {
	lastCall = returnLastCall('a');
	lastCall = returnLastCall('b');
	
	equal(lastCall.get(), 'b');
});

test('given lastCall text print top two trends', function() {
	lastCall = returnLastCall(response);
	var topTwo = printTrends();
	
	equal(topTwo.length, 2);
	equal(topTwo[0], '#endoftheworldconfessions');
	equal(topTwo[1], '#myraptureplaylist');
});

test('given empty lastCall, throw error', function() {
	try{
		lastCall.get();
		ok(false);
	}catch(er){
		if (er.name == 'EmptyLastResponse' && er.message == 'Unable to connect to Twitter'){
			ok(true, 'name and message correct');
		}
	};	
});

function fakeXhr () {
	return xmlHttp = { sendcalled : false,
					openargs : [],
					send : function () {
						this.sendcalled = true;
						}, 
					open : function () {
						this.openargs = arguments;
						} 
					};
};

var response = '{"as_of":"Sat, 21 May 2011 14:13:57 +0000","trends":[{"url":"http:\/\/search.twitter.com\/search?q=%23endoftheworldconfessions","name":"#endoftheworldconfessions"},{"url":"http:\/\/search.twitter.com\/search?q=%23myraptureplaylist","name":"#myraptureplaylist"},{"url":"http:\/\/search.twitter.com\/search?q=%23shemakesmewanna","name":"#shemakesmewanna"},{"url":"http:\/\/search.twitter.com\/search?q=DANCE+TAEMIN","name":"DANCE TAEMIN"},{"url":"http:\/\/search.twitter.com\/search?q=DIVA+KEY","name":"DIVA KEY"},{"url":"http:\/\/search.twitter.com\/search?q=RAPP+MINHO","name":"RAPP MINHO"},{"url":"http:\/\/search.twitter.com\/search?q=DUBU+ONEW","name":"DUBU ONEW"},{"url":"http:\/\/search.twitter.com\/search?q=BLING+JONGHYUN","name":"BLING JONGHYUN"},{"url":"http:\/\/search.twitter.com\/search?q=JUSTINdonesia","name":"JUSTINdonesia"},{"url":"http:\/\/search.twitter.com\/search?q=Jay+Jay+Okocha","name":"Jay Jay Okocha"}]}';